searchNodes=[{"ref":"FunWithFlags.UI.html","title":"FunWithFlags.UI","type":"module","doc":"FunWithFlags.UI, a web dashboard for the FunWithFlags package. See the Readme for more detailed instructions."},{"ref":"FunWithFlags.UI.html#run_standalone/0","title":"FunWithFlags.UI.run_standalone/0","type":"function","doc":"Convenience function to simply run the Plug in Cowboy. This will be supervided, but in the private supervsion tree of :cowboy and :ranch."},{"ref":"FunWithFlags.UI.html#run_supervised/0","title":"FunWithFlags.UI.run_supervised/0","type":"function","doc":"Convenience function to run the Plug in a custom supervision tree. This is just an example. If you actually need this, you might want to use your own supervision setup."},{"ref":"FunWithFlags.UI.Router.html","title":"FunWithFlags.UI.Router","type":"module","doc":"A Plug.Router. This module is meant to be plugged into host applications. See the Readme for more detailed instructions."},{"ref":"FunWithFlags.UI.Router.html#init/1","title":"FunWithFlags.UI.Router.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"readme.html","title":"FunWithFlags.UI","type":"extras","doc":"FunWithFlags.UI A Web dashboard for the FunWithFlags Elixir package."},{"ref":"readme.html#how-to-run","title":"FunWithFlags.UI - How to run","type":"extras","doc":"FunWithFlags.UI is just a plug and it can be run in a number of ways. It&#39;s primarily meant to be embedded in a host Plug application, either Phoenix or another Plug app. Mounted in Phoenix The router plug can be mounted inside the Phoenix router with Phoenix.Router.forward/4. defmodule MyPhoenixApp.Web.Router do use MyPhoenixApp.Web, :router pipeline :mounted_apps do plug :accepts, [&quot;html&quot;] plug :put_secure_browser_headers end scope path: &quot;/feature-flags&quot; do pipe_through :mounted_apps forward &quot;/&quot;, FunWithFlags.UI.Router, namespace: &quot;feature-flags&quot; end end Note: There is no need to add :protect_from_forgery to the :mounted_apps pipeline because this package already implements CSRF protection. In order to enable it, your host application must use the Plug.Session plug, which is usually configured in the endpoint module in Phoenix. Mounted in another Plug application Since it&#39;s just a plug, it can also be mounted into any other Plug application using Plug.Router.forward/2. defmodule Another.App do use Plug.Router forward &quot;/feature-flags&quot;, to: FunWithFlags.UI.Router, init_opts: [namespace: &quot;feature-flags&quot;] end Note: If your plug router uses Plug.CSRFProtection, FunWithFlags.UI.Router should be added before your CSRF protection plug because it already implements its own CSRF protection. If you declare FunWithFlags.UI.Router after, your CSRF plug will likely block GET requests for the JS assets of the dashboard. Standalone Again, because it&#39;s just a plug, it can be run standalone in different ways. If you clone the repository, the library comes with two convenience functions to accomplish this: # Simple, let Cowboy sort out the supervision tree: {:ok, pid} = FunWithFlags.UI.run_standalone() # Uses some explicit supervision configuration: {:ok, pid} = FunWithFlags.UI.run_supervised() These functions come in handy for local development, and are not necessary when embedding the Plug into a host application. Please note that even though the FunWithFlags.UI module implements the Application behavior and comes with a proper start/2 callback, this is not enabled by design and, in fact, the Mixfile doesn&#39;t declare an entry module. If you really need to run it standalone in a reliable manner, you are encouraged to write your own supervision setup. Security For obvious reasons, you don&#39;t want to make this web control panel publicly accessible. The library itself doesn&#39;t provide any auth functionality because, as a Plug, it is easier to wrap it into the authentication and authorization logic of the host application. The easiest thing to do is to protect it with HTTP Basic Auth, provided by the basic_auth plug. For example, in Phoenix: defmodule MyPhoenixApp.Web.Router do use MyPhoenixApp.Web, :router def my_basic_auth(conn, username, password) do if username == &quot;foo&quot; &amp;&amp; password == &quot;bar&quot; do conn else Plug.Conn.halt(conn) end end pipeline :mounted_and_protected_apps do plug :accepts, [&quot;html&quot;] plug :put_secure_browser_headers plug BasicAuth, callback: &amp;__MODULE__.my_basic_auth/3 end scope path: &quot;/feature-flags&quot; do pipe_through :mounted_and_protected_apps forward &quot;/&quot;, FunWithFlags.UI.Router, namespace: &quot;feature-flags&quot; end end"},{"ref":"readme.html#caveats","title":"FunWithFlags.UI - Caveats","type":"extras","doc":"While the base fun_with_flags library is quite relaxed in terms of valid flag names, group names and actor identifers, this web dashboard extension applies some more restrictive rules. The reason is that all fun_with_flags cares about is that some flag and group names can be represented as an Elixir Atom, while actor IDs are just strings. Since you can use that API in your code, the library will only check that the parameters have the right type. Things change on the web, however. Think about the binary &quot;Ook? Ook!&quot;. In code, it can be accepted as a valid flag name: {:ok, true} = FunWithFlags.enable(:&quot;Ook? Ook!&quot;, for_group: :&quot;weird, huh?&quot;) On the web, however, the question mark makes working with URLs a bit tricky: in http://localhost:8080/flags/Ook?%20Ook!, the flag name will be Ook and the rest will be a query string. For this reason this library enforces some stricter rules when creating flags and groups. Blank values are not allowed, ? neither, and flag names must match /^w+$/."},{"ref":"readme.html#installation","title":"FunWithFlags.UI - Installation","type":"extras","doc":"The package can be installed by adding fun_with_flags_ui to your list of dependencies in mix.exs.It requires fun_with_flags, see its installation documentation for more details. def deps do [{:fun_with_flags_ui, &quot;~&gt; 0.7.2&quot;}] end"}]